package com.qiaomeng.flutter.alipay_no_utdid;

import android.app.Activity;
import android.app.Application;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.net.Uri;
import android.os.Bundle;
import android.os.Looper;

import com.alipay.sdk.app.EnvUtils;
import com.alipay.sdk.app.PayTask;

import java.util.List;
import java.util.Map;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;

public class Handler {


    private Activity mActivity;

    public void pay(final MethodCall call, final MethodChannel.Result result) {
        Runnable payRunnable = new Runnable() {

            @Override
            public void run() {
                int payEnv = call.argument("payEnv");
                String order = call.argument("order");
                if (payEnv == 1) {
                    EnvUtils.setEnv(EnvUtils.EnvEnum.SANDBOX);
                } else {
                    EnvUtils.setEnv(EnvUtils.EnvEnum.ONLINE);
                }
                PayTask alipay = new PayTask(mActivity);
                final Map<String, String> map = alipay.payV2(order, true);
                mActivity.runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        result.success(map);
                    }
                });


            }
        };
        // 必须异步调用
        Thread payThread = new Thread(payRunnable);
        payThread.start();
    }

    public void isInstalled(MethodChannel.Result result) {
        PackageManager manager = mActivity.getPackageManager();
        Intent action = new Intent(Intent.ACTION_VIEW, Uri.parse("alipays://"));
        List<ResolveInfo> list = manager.queryIntentActivities(action, PackageManager.GET_RESOLVED_FILTER);
        result.success(list != null && list.size() > 0);
    }

    public void setActivity(Activity a) {
        if (this.mActivity != null || a == null) {
            return;
        }
        this.mActivity = a;
        mActivity.getApplication().registerActivityLifecycleCallbacks(new Application.ActivityLifecycleCallbacks() {
            @Override
            public void onActivityCreated(Activity activity, Bundle savedInstanceState) {
                mActivity = activity;
            }

            @Override
            public void onActivityStarted(Activity activity) {
                mActivity = activity;
            }

            @Override
            public void onActivityResumed(Activity activity) {
                mActivity = activity;
            }

            @Override
            public void onActivityPaused(Activity activity) {

            }

            @Override
            public void onActivityStopped(Activity activity) {

            }

            @Override
            public void onActivitySaveInstanceState(Activity activity, Bundle outState) {

            }

            @Override
            public void onActivityDestroyed(Activity activity) {

            }
        });
    }

}
