import 'dart:async';

import 'package:flutter/services.dart';

class AlipayNoUtdid {
  static const MethodChannel _channel = const MethodChannel('alipay_no_utdid');

  static Future<AlipayResult> pay(String order,
      {AliPayEvn payEnv = AliPayEvn.ONLINE}) async {
    var map = await _channel
        .invokeMethod('pay', {"order": order, "payEnv": payEnv.index});
    return AlipayResult.fromJson(map);
  }

  static Future<bool> isInstalled() {
    return _channel.invokeMethod('isInstalled');
  }
}

enum AliPayEvn { ONLINE, SANDBOX }

class AlipayResult {
  String msg;
  String code;
  bool get isSuccessful => code == '9000';

  AlipayResult.fromJson(Map map) {
    msg = map['memo'];
    code = map['resultStatus'];
  }

  Map<String,dynamic> toMap(){
    return {
      "msg":msg,
      "code":code,
      "isSuccessful":isSuccessful,
    };
  }
}
